var Article = React.createClass({
    render: function() {
        var categoryNodes = this.props.article.categories.map(function(category){
            return (
                <a href={category.search_url}>{category.name}</a>
            );
        });
        var areaNodes = this.props.article.areas.map(function(area){
            return (
                <a href={area.search_url}>{area.name}</a>
            );
        });
         var articleTitle = this.props.article.title;
            if(navigator.userAgent.match(/(iPhone|iPod|Android)/)){
            if (articleTitle.length > 25) {    // Adjusted with iPhone 6 width(width=375px). originally 22.
                articleTitle = articleTitle.substring(0, 24) + "..."; // originally 22.
            }
        } else{
            if (articleTitle.length > 34) {
                articleTitle = articleTitle.substring(0, 34) + "...";
            }
        }
        return (
            <li>
                <div className="imgSide">
                    <a href={this.props.article.permalink}>
                        <img src={this.props.article.image.url} alt={this.props.article.image.alt} />
                    </a>
                </div>
                <div className="textSide">
                    <h3 className="listHeadLine"><a href={this.props.article.permalink}>{articleTitle}</a></h3>
                    <p>{this.props.article.excerpt}</p>
                    <ul>
                        <li className="pc">{this.props.article.date}</li>
                        <li className="area">{categoryNodes}</li>
                        <li className="area">{areaNodes}</li>
                        <li className="sp">{this.props.article.date}</li>
                    </ul>
                </div>
            </li>
        );
    }
});

var ArticleList = React.createClass({
    getInitialState: function() {
        return {articles: []};
    },
    componentDidMount: function() {
        var url = "";
        var post_id = $('#relational-list').data('post-id');
        if (this.props.mode == 'new') {
            url = "/api/search?orderby=post_date&order=desc&posts_per_page=4&exclude[]="+post_id;
        } else if ( this.props.mode == 'same-category-popular' ) {
            var query = $('#same-category-popular-list').data('query');
            url = "/api/search?"+query+"&orderby=views&order=desc&posts_per_page=4&exclude[]="+post_id;
        } else if ( this.props.mode == 'relational' ) {
            url = "/api/relational?post_id="+post_id;
        }

        $.ajax({
            url: url,
            dataType: 'json',
            cache: false,
            success: function(result) {
                var articles = result.posts;
                this.setState({articles: articles});
            }.bind(this),
            error: function(xhr, status, err) {
                console.error(this.props.url, status, err.toString());
            }.bind(this)
        });
    },
    render: function() {
        var articleNodes = this.state.articles.map(function(article){
            return (
                <Article article={article} />
            );
        });
        return (
            <ul className="thumbList">
                {articleNodes}
            </ul>
        );
    }
});

ReactDOM.render(
    <ArticleList mode="relational" />,
    document.getElementById('relational-list')
);

ReactDOM.render(
    <ArticleList mode="same-category-popular" />,
    document.getElementById('same-category-popular-list')
);

ReactDOM.render(
    <ArticleList mode="new" />,
    document.getElementById('new-list')
);